package de.juplo.jackson;


import com.fasterxml.jackson.core.JsonFactory;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.Reader;
import java.net.URL;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Spliterator;
import java.util.stream.Stream;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.Assert;



/**
 *
 * @author kai
 */
@Component
public class SimpleMapperService
    extends
      SimpleMapper
    implements
      InitializingBean
{
  @Autowired(required = false)
  private JsonFactory factory;


  public SimpleMapperService() {}

  public SimpleMapperService(JsonFactory factory)
  {
    this.factory = factory;
  }


  @Override
  public void afterPropertiesSet() throws Exception
  {
    Assert.notNull(factory, "The attribute factory must be set!");
  }

  public JsonFactory getFactory()
  {
    return factory;
  }


  public Spliterator<Object> getArraySpliterator(File file)
      throws
        IOException
  {
    return getArraySpliterator(factory.createParser(file));
  }

  public Spliterator<Object> getArraySpliterator(InputStream is)
      throws
        IOException
  {
    return getArraySpliterator(factory.createParser(is));
  }

  public Spliterator<Object> getArraySpliterator(Reader r)
      throws
        IOException
  {
    return getArraySpliterator(factory.createParser(r));
  }

  public Spliterator<Object> getArraySpliterator(String content)
      throws
        IOException
  {
    return getArraySpliterator(factory.createParser(content));
  }

  public Spliterator<Object> getArraySpliterator(URL url)
      throws
        IOException
  {
    return getArraySpliterator(factory.createParser(url));
  }

  public Spliterator<Object> getArraySpliterator(byte[] data)
      throws
        IOException
  {
    return getArraySpliterator(factory.createParser(data));
  }

  public Spliterator<Object> getArraySpliterator(char[] content)
      throws
        IOException
  {
    return getArraySpliterator(factory.createParser(content));
  }

  public Spliterator<Object> getArraySpliterator(byte[] data, int offset, int len)
      throws
        IOException
  {
    return getArraySpliterator(factory.createParser(data, offset, len));
  }

  public Spliterator<Object> getArraySpliterator(char[] data, int offset, int len)
      throws
        IOException
  {
    return getArraySpliterator(factory.createParser(data, offset, len));
  }

  public Stream<Object> getArrayStream(File file)
      throws
        IOException
  {
    return getArrayStream(factory.createParser(file));
  }

  public Stream<Object> getArrayStream(InputStream is)
      throws
        IOException
  {
    return getArrayStream(factory.createParser(is));
  }

  public Stream<Object> getArrayStream(Reader r)
      throws
        IOException
  {
    return getArrayStream(factory.createParser(r));
  }

  public Stream<Object> getArrayStream(String content)
      throws
        IOException
  {
    return getArrayStream(factory.createParser(content));
  }

  public Stream<Object> getArrayStream(URL url)
      throws
        IOException
  {
    return getArrayStream(factory.createParser(url));
  }

  public Stream<Object> getArrayStream(byte[] data)
      throws
        IOException
  {
    return getArrayStream(factory.createParser(data));
  }

  public Stream<Object> getArrayStream(char[] content)
      throws
        IOException
  {
    return getArrayStream(factory.createParser(content));
  }

  public Stream<Object> getArrayStream(byte[] data, int offset, int len)
      throws
        IOException
  {
    return getArrayStream(factory.createParser(data, offset, len));
  }

  public Stream<Object> getArrayStream(char[] data, int offset, int len)
      throws
        IOException
  {
    return getArrayStream(factory.createParser(data, offset, len));
  }

  public Iterator<Object> getArrayIterator(File file)
      throws
        IOException
  {
    return getArrayIterator(factory.createParser(file));
  }

  public Iterator<Object> getArrayIterator(InputStream is)
      throws
        IOException
  {
    return getArrayIterator(factory.createParser(is));
  }

  public Iterator<Object> getArrayIterator(Reader r)
      throws
        IOException
  {
    return getArrayIterator(factory.createParser(r));
  }

  public Iterator<Object> getArrayIterator(String content)
      throws
        IOException
  {
    return getArrayIterator(factory.createParser(content));
  }

  public Iterator<Object> getArrayIterator(URL url)
      throws
        IOException
  {
    return getArrayIterator(factory.createParser(url));
  }

  public Iterator<Object> getArrayIterator(byte[] data)
      throws
        IOException
  {
    return getArrayIterator(factory.createParser(data));
  }

  public Iterator<Object> getArrayIterator(char[] content)
      throws
        IOException
  {
    return getArrayIterator(factory.createParser(content));
  }

  public Iterator<Object> getArrayIterator(byte[] data, int offset, int len)
      throws
        IOException
  {
    return getArrayIterator(factory.createParser(data, offset, len));
  }

  public Iterator<Object> getArrayIterator(char[] data, int offset, int len)
      throws
        IOException
  {
    return getArrayIterator(factory.createParser(data, offset, len));
  }


  public Spliterator<Map.Entry<String, Object>> getObjectSpliterator(File file)
      throws
        IOException
  {
    return getObjectSpliterator(factory.createParser(file));
  }

  public Spliterator<Map.Entry<String, Object>> getObjectSpliterator(InputStream is)
      throws
        IOException
  {
    return getObjectSpliterator(factory.createParser(is));
  }

  public Spliterator<Map.Entry<String, Object>> getObjectSpliterator(Reader r)
      throws
        IOException
  {
    return getObjectSpliterator(factory.createParser(r));
  }

  public Spliterator<Map.Entry<String, Object>> getObjectSpliterator(String content)
      throws
        IOException
  {
    return getObjectSpliterator(factory.createParser(content));
  }

  public Spliterator<Map.Entry<String, Object>> getObjectSpliterator(URL url)
      throws
        IOException
  {
    return getObjectSpliterator(factory.createParser(url));
  }

  public Spliterator<Map.Entry<String, Object>> getObjectSpliterator(byte[] data)
      throws
        IOException
  {
    return getObjectSpliterator(factory.createParser(data));
  }

  public Spliterator<Map.Entry<String, Object>> getObjectSpliterator(char[] content)
      throws
        IOException
  {
    return getObjectSpliterator(factory.createParser(content));
  }

  public Spliterator<Map.Entry<String, Object>> getObjectSpliterator(byte[] data, int offset, int len)
      throws
        IOException
  {
    return getObjectSpliterator(factory.createParser(data, offset, len));
  }

  public Spliterator<Map.Entry<String, Object>> getObjectSpliterator(char[] data, int offset, int len)
      throws
        IOException
  {
    return getObjectSpliterator(factory.createParser(data, offset, len));
  }

  public Stream<Map.Entry<String, Object>> getObjectStream(File file)
      throws
        IOException
  {
    return getObjectStream(factory.createParser(file));
  }

  public Stream<Map.Entry<String, Object>> getObjectStream(InputStream is)
      throws
        IOException
  {
    return getObjectStream(factory.createParser(is));
  }

  public Stream<Map.Entry<String, Object>> getObjectStream(Reader r)
      throws
        IOException
  {
    return getObjectStream(factory.createParser(r));
  }

  public Stream<Map.Entry<String, Object>> getObjectStream(String content)
      throws
        IOException
  {
    return getObjectStream(factory.createParser(content));
  }

  public Stream<Map.Entry<String, Object>> getObjectStream(URL url)
      throws
        IOException
  {
    return getObjectStream(factory.createParser(url));
  }

  public Stream<Map.Entry<String, Object>> getObjectStream(byte[] data)
      throws
        IOException
  {
    return getObjectStream(factory.createParser(data));
  }

  public Stream<Map.Entry<String, Object>> getObjectStream(char[] content)
      throws
        IOException
  {
    return getObjectStream(factory.createParser(content));
  }

  public Stream<Map.Entry<String, Object>> getObjectStream(byte[] data, int offset, int len)
      throws
        IOException
  {
    return getObjectStream(factory.createParser(data, offset, len));
  }

  public Stream<Map.Entry<String, Object>> getObjectStream(char[] data, int offset, int len)
      throws
        IOException
  {
    return getObjectStream(factory.createParser(data, offset, len));
  }

  public Iterator<Map.Entry<String, Object>> getObjectIterator(File file)
      throws
        IOException
  {
    return getObjectIterator(factory.createParser(file));
  }

  public Iterator<Map.Entry<String, Object>> getObjectIterator(InputStream is)
      throws
        IOException
  {
    return getObjectIterator(factory.createParser(is));
  }

  public Iterator<Map.Entry<String, Object>> getObjectIterator(Reader r)
      throws
        IOException
  {
    return getObjectIterator(factory.createParser(r));
  }

  public Iterator<Map.Entry<String, Object>> getObjectIterator(String content)
      throws
        IOException
  {
    return getObjectIterator(factory.createParser(content));
  }

  public Iterator<Map.Entry<String, Object>> getObjectIterator(URL url)
      throws
        IOException
  {
    return getObjectIterator(factory.createParser(url));
  }

  public Iterator<Map.Entry<String, Object>> getObjectIterator(byte[] data)
      throws
        IOException
  {
    return getObjectIterator(factory.createParser(data));
  }

  public Iterator<Map.Entry<String, Object>> getObjectIterator(char[] content)
      throws
        IOException
  {
    return getObjectIterator(factory.createParser(content));
  }

  public Iterator<Map.Entry<String, Object>> getObjectIterator(byte[] data, int offset, int len)
      throws
        IOException
  {
    return getObjectIterator(factory.createParser(data, offset, len));
  }

  public Iterator<Map.Entry<String, Object>> getObjectIterator(char[] data, int offset, int len)
      throws
        IOException
  {
    return getObjectIterator(factory.createParser(data, offset, len));
  }


  public List<Object> convertArray(File file) throws Exception
  {
    return convertArray(factory.createParser(file));
  }

  public List<Object> convertArray(InputStream is) throws Exception
  {
    return convertArray(factory.createParser(is));
  }

  public List<Object> convertArray(Reader r) throws Exception
  {
    return convertArray(factory.createParser(r));
  }

  public List<Object> convertArray(String content) throws Exception
  {
    return convertArray(factory.createParser(content));
  }

  public List<Object> convertArray(URL url) throws Exception
  {
    return convertArray(factory.createParser(url));
  }

  public List<Object> convertArray(byte[] data) throws Exception
  {
    return convertArray(factory.createParser(data));
  }

  public List<Object> convertArray(char[] content) throws Exception
  {
    return convertArray(factory.createParser(content));
  }

  public List<Object> convertArray(byte[] data, int offset, int len)
      throws
        Exception
  {
    return convertArray(factory.createParser(data, offset, len));
  }

  public List<Object> convertArray(char[] content, int offset, int len)
      throws
        Exception
  {
    return convertArray(factory.createParser(content, offset, len));
  }

  public Map<String, Object> convertObject(File file) throws Exception
  {
    return convertObject(factory.createParser(file));
  }

  public Map<String, Object> convertObject(InputStream is) throws Exception
  {
    return convertObject(factory.createParser(is));
  }

  public Map<String, Object> convertObject(Reader r) throws Exception
  {
    return convertObject(factory.createParser(r));
  }

  public Map<String, Object> convertObject(String content) throws Exception
  {
    return convertObject(factory.createParser(content));
  }

  public Map<String, Object> convertObject(URL url) throws Exception
  {
    return convertObject(factory.createParser(url));
  }

  public Map<String, Object> convertObject(byte[] data) throws Exception
  {
    return convertObject(factory.createParser(data));
  }

  public Map<String, Object> convertObject(char[] content) throws Exception
  {
    return convertObject(factory.createParser(content));
  }

  public Map<String, Object> convertObject(byte[] data, int offset, int len)
      throws
        Exception
  {
    return convertObject(factory.createParser(data, offset, len));
  }

  public Map<String, Object> convertObject(char[] content, int offset, int len)
      throws
        Exception
  {
    return convertObject(factory.createParser(content, offset, len));
  }

  public Object convert(File file) throws Exception
  {
    return convert(factory.createParser(file));
  }

  public Object convert(InputStream is) throws Exception
  {
    return convert(factory.createParser(is));
  }

  public Object convert(Reader r) throws Exception
  {
    return convert(factory.createParser(r));
  }

  public Object convert(String content) throws Exception
  {
    return convert(factory.createParser(content));
  }

  public Object convert(URL url) throws Exception
  {
    return convert(factory.createParser(url));
  }

  public Object convert(byte[] data) throws Exception
  {
    return convert(factory.createParser(data));
  }

  public Object convert(char[] content) throws Exception
  {
    return convert(factory.createParser(content));
  }

  public Object convert(byte[] data, int offset, int len)
      throws
        Exception
  {
    return convert(factory.createParser(data, offset, len));
  }

  public Object convert(char[] content, int offset, int len)
      throws
        Exception
  {
    return convert(factory.createParser(content, offset, len));
  }
}
